ShapefileFeatureTable class final

A table of features that typically represents real-world objects created from a local shapefile data source.

A shapefile is a vector data storage format that stores the location, shape, and attributes of geographic features with the same geometry type (such as point, line, and polygon) and the same spatial reference. A shapefile dataset consists of at least three files (.shp, .shx, .dbf), and may include many others. Each of the component files of a shapefile must be smaller than 2 GB. If the minimum required files are not present (or are larger than 2 GB), the table will fail to load. If the file permissions are read-only, features cannot be edited.

See Shapefiles in ArcGIS Pro for more information about shapefile data types and limitations.

On-the-fly projection of a shapefile is supported if an associated .prj file is present. Otherwise, the features are assumed to have the same spatial reference as the map.

A default renderer is used to render a shapefile feature table in a feature layer. In most cases, the default should be replaced with a custom renderer.

Inheritance

Constructors

ShapefileFeatureTable.withFileUri(Uri shapefileUri)
Creates a shapefile feature table from the local shapefile (.shp) at the given path.
factory

Properties

displayName ↔ String
A user-friendly name that can be displayed in the UI (for example, in a Table of Contents).
getter/setter pairinherited
extent → Envelope?
The geographic extent of features within the table.
no setterinherited
fields → List<Field>
The collection of Field objects representing the fields of the feature table.
no setterinherited
fileUri → Uri
The path to the shapefile.
no setter
geometryType → GeometryType
The type of geometry of the features stored in this table.
no setterinherited
hasGeometry → bool
True if the feature table supports geographic features, false otherwise.
no setterinherited
hashCode → int
The hash code for this object.
no setterinherited
hasM → bool
True if the feature table supports geometries with M values, false otherwise.
no setterinherited
hasZ → bool
True if the feature table supports geometries with Z values, false otherwise.
no setterinherited
info → ShapefileInfo?
Shapefile info that contains metadata for the dataset.
no setter
isEditable → bool
True if this feature table is editable, false otherwise.
no setterinherited
isPopupEnabled ↔ bool
A flag indicating whether the PopupDefinition defined on the PopupSource is enable / disable.
getter/setter pairinherited
layer → Layer?
The layer that displays this table, if any.
no setterinherited
loadError → ArcGISException?
The load error.
no setterinherited
loadStatus → LoadStatus
The load status.
no setterinherited
numberOfFeatures → int
The number of features in the table.
no setterinherited
onLoadStatusChanged → Stream<LoadStatus>
A stream that reports changes to the LoadStatus.
no setterinherited
popupDefinition ↔ PopupDefinition?
The pop-up definition.
getter/setter pairinherited
runtimeType → Type
A representation of the runtime type of the object.
no setterinherited
spatialIndexEnabled → bool
True if the shapefile has a spatial index, false otherwise.
no setter
spatialReference → SpatialReference?
The spatial reference of the table.
no setterinherited
tableName → String
The name of the table in the source dataset.
no setterinherited

Methods

addFeature(Feature feature) → Future<void>
Adds a feature to the table.
inherited
addFeatures(List<Feature> features) → Future<void>
Adds a collection of features to the table.
inherited
canAdd() → bool
Determines whether you can add new features to the table.
inherited
cancelLoad() → void
Cancels loading metadata for the object.
inherited
canDelete(Feature feature) → bool
Determines whether you can delete the feature from the table.
inherited
canEditGeometry() → bool
Determines whether you can edit the geometry field in a table.
inherited
canUpdate(Feature feature) → bool
Determines whether you can update the feature in the table.
inherited
close() → void
Closes the shapefile feature table.
createFeature({Map<CaseInsensitiveString, dynamic> attributes = const {}, Geometry? geometry}) → Feature
Creates a new feature with the provided attribute values and, optionally, geometry.
inherited
deleteFeature(Feature feature) → Future<void>
Deletes a feature from the table.
inherited
deleteFeatures(List<Feature> features) → Future<void>
Deletes a collection of features from the table.
inherited
getField({required String fieldName}) → Field?
Retrieves the field with the given name.
inherited
getPopupDefinitionWithFeature(Feature feature) → PopupDefinition?
Gets the popup definition for the given feature in the feature table.
inherited
load() → Future<void>
Loads the metadata for the object asynchronously.
inherited
noSuchMethod(Invocation invocation) → dynamic
Invoked when a nonexistent method or property is accessed.
inherited
queryExtent(QueryParameters queryParameters) → Future<Envelope>
Determines the minimum bounding envelope that contains features satisfying the provided query parameters.
inherited
queryFeatureCount(QueryParameters queryParameters) → Future<int>
Determines the count of features that satisfy the provided query parameters.
inherited
queryFeatures(QueryParameters queryParameters) → Future<FeatureQueryResult>
Submits a query against the table.
inherited
queryStatistics(StatisticsQueryParameters statisticsQueryParameters) → Future<StatisticsQueryResult>
Calculates values for the requested statistics.
inherited
retryLoad() → Future<void>
Loads or retries loading metadata for the object asynchronously.
inherited
toString() → String
A string representation of this object.
inherited
updateFeature(Feature feature) → Future<void>
Updates a feature in the table.
inherited
updateFeatures(List<Feature> features) → Future<void>
Updates a collection of features in the table.
inherited

Operators

operator ==(Object other) → bool
The equality operator.
inherited